## $Id: batching.py 12371 2015-01-03 07:38:07Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Batch processing for pcn documents.
"""
import grok
from waeup.ikoba.customers.batching import (
    CustomerProcessor,
    CustomerDocumentProcessorBase, ContractProcessorBase)
from ikobacustom.pcn.customers.interfaces import (
    IPCNCustomer,
    IPCNCustomerDocument, IPCNContract)
from ikobacustom.pcn.interfaces import MessageFactory as _


class PCNCustomerProcessor(CustomerProcessor):
    """A batch processor for ICustomer objects.
    """
    util_name = 'pcncustomerprocessor'
    grok.name(util_name)
    name = _('PCN Customer Processor')
    iface = IPCNCustomer


class PCNCustomerDocumentProcessor(CustomerDocumentProcessorBase):
    """A batch processor for IPCNCustomerDocument objects.
    """
    util_name = 'pcncustomerdocumentprocessor'
    grok.name(util_name)
    name = _('PCN Customer Document Processor')
    iface = IPCNCustomerDocument
    factory_name = 'waeup.PCNCustomerDocument'


class PCNContractProcessor(ContractProcessorBase):
    """A batch processor for IPCNContract objects.
    """
    util_name = 'pcncontractprocessor'
    grok.name(util_name)
    name = _('PCN Customer Contract Processor')
    iface = IPCNContract
    factory_name = 'waeup.PCNContract'